<?
/*-------------------------------------------------------------------
 * α׷ : Mail Ŭ Ѵ.
 * Ư   : 1.MIME(Multipurpose Internet Mail Extensions) 
                2.SMTP(Simple Mail Transfer Protocol) 
 *  table :
 * SERVICES   :
 *      : ö
 * ۼ   : 2001/05
 *      :
 *    :
 *    :
 *-------------------------------------------------------------------*/

class Mime
{
  var $parts;
  var $to;
  var $from;
  var $name;
  var $headers;
  var $subject;
  var $body;

  // Ŭ 
  function Mime()
  {
    $this->parts = array();
    $this->to = "";
    $this->from	= "";
    $this->headers ="";
    $this->subject ="";
    $this->body	="";
  }

  // ϰü ÷  ߰Ѵ.
  function add_attachment($message,$name="",$ctype="text/plain",$charset="euc-kr",$encode="base64")
  {
    $this->parts[] = array(
      "message"=>$message,    
      "name"=>$name,      
      "ctype"=>$ctype,
      "charset"=>$charset,
      "encode"=>$encode
    );
  }

  //  κ е  ޽ κе .
  function build_message($part)
  {
    $message = $part["message"];  	
    $name = $part["name"];    
    $ctype = $part["ctype"];
    $charset = $part["charset"];
    $encode = $part["encode"];

    switch($encode)
    {
      case 'base64':
        $message = chunk_split(base64_encode($message));
        break;
    }//End switch

    $text = "Content-Type: $ctype";
    $text .= ($charset)?";charset=\"".$charset."\"":"";
    $text .= ($name)?";name=\"".$name."\"":"";
    $text .= "\r\nContent-Transfer-Encoding: $encode\r\n\r\n$message\r\n";

    return $text;
  }

  // κ   Ѵ.
  function build_multipart()
  {
    $boundary = "b".md5(uniqid(rand()));

    $multipart = "Content-Type: multipart/mixed;\r\n";
    $multipart .= "    boundary=\"$boundary\"\r\n\r\n";
    $multipart .= "This is a multi-part message in MIME format.\r\n--$boundary";

    for($i=sizeof($this->parts)-1;$i>=0;$i--)
    {
      $multipart .= "\r\n".$this->build_message($this->parts[$i])."--$boundary";
    }//End for

    return $multipart.="--\r\n";
  }

  //   Ѵ.
  function get_mail($complete = true)
  {
    $mime = "";

    if(!empty($this->from))
      $mime .= "From: $this->from($this->from)\r\n";

    if(!empty($this->headers))
      $mime .= $this->headers."\r\n";

    if($complete)
    {
      if(!empty($this->to))
        $mime .= "To: $this->to\r\n";

      if(!empty($this->subject))
        $mime .= "Subject: $this->subject\r\n";
    }//End if

    if(!empty($this->body))
      $this->add_attachment($this->body);

    $mime .= "MIME-Version: 1.0\r\n";
    $mime .= $this->build_multipart();
    return $mime;
  }

  //  Ѵ.
  function send()
  {
    $mime = $this->get_mail(false);
    return @mail($this->to,$this->subject,"",$mime);
  }
}

class Smtp
{
  var $smtp_server;
  var $to;
  var $from;
  var $data;
  var $subject;

  var $fp = false;
  var $lastmsg = "";

  // Ŭ 
  function Smtp($smtp_server = "localhost")
  {
    $this->smtp_server = $smtp_server;
    $this->to = "";
    $this->from	= "";
    $this->data = "";
    $this->subject = "";
  }

  // κ   а,
  // NUMERIC ڵ   Ѵ.
  function read_line()
  {
    $result = false;
    $line = @fgets($this->fp,1024);

    if(ereg("^([0-9]+).(.*)$",$line,&$data))
    {
      $recv_code = $data[1];
      $recv_msg  = $data[2];
      $result = array($recv_code,$recv_msg);
    }//End if

    return $result;
  }

  //   $cmd ɾ ϰ,
  // ϵ NUMERIC ڵ尡 Ǿ ڵ θ üũѴ.
  function dialogue($code,$cmd)
  {
    fwrite($this->fp, $cmd."\r\n");
    $line = $this->read_line($this->fp);
    if($line == false)
    {
      $this->lastmsg = "";
      return false;
    }else{
      $this->lastmsg = "$line[0] $line[1]";
      return ($line[0] == $code);
    }//End if else
  }

  // SMTP κ ŵ 
  // ޽   ޽ Ѵ.
  function error_message()
  {
    echo "SMTP protocol failure (".$this->lastmsg.").<br>";
  }

  //  (CR/LF) ġѴ.
  // RFC 788   CRLF(hex 0x13 0x10) Ѵ.
  function crlf_encode($data)
  {
    return ereg_replace("\r?\n\.\r?\n", "\n .\n", $data);
  }

  // SMTP  ǻ Ѵ.
  function handle_Email($from,$to,$data)
  {
    // split recipient list
    $rcpts = explode(",",$to);

    $err = false;
    if(!$this->dialogue(250,"HELO phpclient")||
    	!$this->dialogue(250,"MAIL FROM:$from")) $err = true;

    for($i = 0; !$err && $i < count($rcpts); $i++)
    {
      if(!$this->dialogue(250,"RCPT TO:$rcpts[$i]")) $err = true;
    }//End for

    if($err||
    	!$this->dialogue(354,"DATA")||
        !fwrite($this->fp, $data)||
    	!$this->dialogue(250,".")||
    	!$this->dialogue(221,"QUIT"))
    	$err = true;

    if($err) $this->error_message();

    return !$err;
  }

  //  ˷ Ʈ(25) SMTP  Ѵ.
  function connect()
  {
    $this->fp = fsockopen($this->smtp_server,25);
    if($this->fp) return true;
    return false;
  }

  // SMTP  ϰ,
  // ޼  ȣȭϿ,
  // Ÿ Ѵ.
  function send_Email($from, $to, $data, $crlf_encode = 0)
  {
    if(!$this->connect())
    {
      echo "cannot open socket<br>\n";
      return false;
    }//End if

    $line = $this->read_line();

    $result = false;
    if($line && $line[0] == "220")
    {
      if($crlf_encode) $data = $this->crlf_encode($data);
      $result = $this->handle_Email($from,$to,$data);
    }else{
      $this->error_message();
    }//End if else

    fclose($this->fp);
    return $result;
  }
}
?>